/******** XIA Projects 2005 copyright ************
 * libKXDocker.so generic Header auto-generated  *
 * this is a part of KXDocker GPL project        *
 * XIA Projects 2005                             *
 * http://www.xiaprojects.com                    *
 * Main developer dr. Stefano Zingarini          *
 * stefano@xiaprojects.com                       *
 *************************************************/

#ifndef LIBKXDOCKERINCLUDES
#define LIBKXDOCKERINCLUDES
#define KXDOCKERCOMPILETIME "20070503"

/*--HEADERSTART--*/

const int DRAW_Pixmap		=0;
const int DRAW_GaugeHoriz	=1;
const int DRAW_GaugeVert	=2;
const int DRAW_GaugeVert2	=3;
const int DRAW_Text		=4;
const int DRAW_ImageFX		=5;

#include <qwidget.h>
#include <qrect.h>


class QImage;
class QPixmap;
class KImageEffect;

/**
@author Stefano Zingarini
*/
class gPluginPainter : public QWidget
{
Q_OBJECT
public:
    gPluginPainter(gPluginPainter *parent = 0, const char *name = 0, int type=0);
    ~gPluginPainter();
    void paint(QPixmap *);
    QImage setFX(QImage &, int,int,int,int);
    QImage setFXRotateX(QImage &,int);
    QImage setFXRotateY(QImage &,int);
    QImage setFXIntensity(QImage &,int);
    QImage setFXGray(QImage &);
	static int SizeBig;
//	KImageEffect *ImageEffect;
protected:
		QRect Zone;
		int Type;
		// custom var
		QPixmap *Pixmap;
		QString Value;
public slots:
    void setValue(const QString);
    void setRect(const QRect);
    void load(const QString);
};

/*--HEADERSTOP--*/
/*--HEADERSTART--*/

#include <qobject.h>
#include <qstring.h>
#include <qstringlist.h>

class QWidget;
class gPluginPainter;
class QImage;
class QDomNodeList;
class KPopupMenu;

const char KXDOCKER_VARTYPE_BOOL[] 	= "bool";
const char KXDOCKER_VARTYPE_PERCENT[] 	= "%";
const char KXDOCKER_VARTYPE_INT[] 	= "int";
const char KXDOCKER_VARTYPE_RANGE[] 	= "range";
const char KXDOCKER_VARTYPE_STRING[] 	= "string";
const char KXDOCKER_VARTYPE_ICON[]	= "icon";
const char KXDOCKER_VARTYPE_LIST[]	= "list";
const char KXDOCKER_VARTYPE_PATH[]	= "path";

/**
@author Stefano Zingarini
*/
class gPluginSDK : public QObject
{
Q_OBJECT
public:
    gPluginSDK(QObject *parent = 0, const char *name = 0);

    ~gPluginSDK();
    virtual QObject * Respawn(QObject *);

protected:
	void createXMLTree();
	void xPaintFX(int);
	int 			isStopped;
	int 			lastValue;
	int 			Value;
	int			ActiveConfigurationSizeOf;
	QString			ActiveConfigurationVersion;
	QString			IconsPath;
	QString			ToolTip;
	QString			ToolTip2;
	QString			LastToolTip2;
	QStringList		PluginInformations;
	int 			SizeBig;
	int			ImageFX_Y_degree;
	int			ImageFX_X_degree;
	int			ImageFX_GrayScale;
	int			ImageFX_Intensity;
	gPluginPainter		*ImageFX_Painter;
	QObject			*xGDocker;
	QObject			*xEConfigurator;
	void			*pActiveConfiguration;
	QObject			*xGIcon;
	QImage			*xImgSource;
	const QDomNodeList	*xXMLIconConfig;
	KPopupMenu		*PluginPopupMenu;
	QWidget 	*ConfigurationWindow;
public slots:
    virtual void xSetup();
    virtual void xRefreshIcon(QObject *);
    virtual void xStop();
    virtual void xStart();
    virtual void xAttach(QObject *);
    virtual void xApplyCfg();
    virtual void polling();
    virtual void xSetupParameter(const QString, const QString);
    virtual void xGetParameterList(QStringList *);
    virtual void xGetParameter(const QString, QString&);
    virtual void xGetInfo(QStringList &);
    virtual void xRunConfigurator();
    virtual void xEnabledClick(int &);
    virtual void xPaint(int);
    virtual void xEventClick(void *,int,int,int,int);
    virtual void xRefreshIconFromKXDocker(QObject *);
    virtual void xGetParameterType(const QString &, QString &);
    virtual void xContinue();
    virtual void xPause();
    virtual void xReAttach(QObject *);
public:
signals:
void cachePurge();
void xSetSmoothZoom();
void xDockerRedraw(QObject *);
void xGetDocker(QObject *&);
void xGetConfigurator(QObject *&);
void xSetText(const QString &);
void xGetImage(QImage *&);
void xGetPluginConfiguration(const QDomNodeList *&);
void xFindResource(const QString &, QString &);
void xGetPluginPopupMenu(KPopupMenu *&,const QObject *);
void xSetIconEXE(const QString &);
void xGetIconEXE(QString &);
void xGetIconImgFile(QString &);
void xGetIconName(QString &);
void xSetIconImgFile(const QString &);
void xSetIconName(const QString &);
void xSetOverText(const QString &);
void xGetConfigurationVersion(int &, QString &);
void xGetConfiguration(void *&,const QString, int);
void xGetConfigurationValue(const QString, int &);
void xGetConfigurationValue(const QString, QString &);
void xSetText(const QString &, int);
void xSetMiniText(const QString &);
void xSetTextManagedBy(int,int);
void xSetOverlayImage(int,int,const QString &);
void xSetOverlayImage(int,int,const QImage &);
void xSetOverlayImage(int,int,const QPixmap &);
void xStartStepping();
void xAskContinue(QObject *);
void xWMSetupParameter(const QString, const QString);
void xWMShow();
};

/*--HEADERSTOP--*/
/*--HEADERSTART--*/

// 0.33
#define KXDOCKERVERSION		"1.1.4a"
#define KXDOCKERNEED		"0.0.16"
#define KXDOCKERDATE		"20060417"
#define KXDOCKERHEADERVERSION	"1.0.0"

// 0.37 Gnome support
// 0.37 KDE support
#define USE_KWIN

 
// by default 0.26 support threading
// to enable GPipe plugin 15Gen2005
// #define QT_THREAD_SUPPORT

// enable interpolation engine
#define ENABLE_SPECIALENGINE2

// enable exit by X axis
#define ENABLE_SPECIALENGINE3

// diable HUGE CACHE
#define DISABLE_HUGE_CACHE

// this will disable debug messages and a lot of tests!!!
#define ENABLE_FINAL

// Enable counters and gui statistics, it's a good choice to let's docker know you
#define ENABLE_STATS


// Enable fork to background
#define DAEMON

#define PILLOWMAXHEIGHT 60


/*--HEADERSTOP--*/
/*--HEADERSTART--*/


#include <sys/types.h>

#include <stdlib.h>

#include <qpoint.h>
#include <qobject.h>
#include <qvaluelist.h>
#include <qptrlist.h>
#include <qpixmap.h>

#include <dcopobject.h>
#include <kwin.h>
#include <kstartupinfo.h>

class TaskManager;

/**
 * A dynamic interface to a task (main window).
 *
 * @see TaskManager
 * @see KWinModule
 */
class Task: public QObject
{
    Q_OBJECT
    Q_PROPERTY( QString visibleIconicName READ visibleIconicName )
    Q_PROPERTY( QString iconicName READ iconicName )
    Q_PROPERTY( QString visibleIconicNameWithState READ visibleIconicNameWithState )
    Q_PROPERTY( QString visibleName READ visibleName )
    Q_PROPERTY( QString name READ name )
    Q_PROPERTY( QString visibleNameWithState READ visibleNameWithState )
    Q_PROPERTY( QPixmap pixmap READ pixmap )
    Q_PROPERTY( bool maximized READ isMaximized )
    Q_PROPERTY( bool minimized READ isMinimized )
    // KDE4 deprecated
    Q_PROPERTY( bool iconified READ isIconified )
    Q_PROPERTY( bool shaded READ isShaded WRITE setShaded )
    Q_PROPERTY( bool active READ isActive )
    Q_PROPERTY( bool onCurrentDesktop READ isOnCurrentDesktop )
    Q_PROPERTY( bool onAllDesktops READ isOnAllDesktops )
    Q_PROPERTY( bool alwaysOnTop READ isAlwaysOnTop WRITE setAlwaysOnTop )
    Q_PROPERTY( bool modified READ isModified )
    Q_PROPERTY( bool demandsAttention READ demandsAttention )
    Q_PROPERTY( int desktop READ desktop )
    Q_PROPERTY( double thumbnailSize READ thumbnailSize WRITE setThumbnailSize )
    Q_PROPERTY( bool hasThumbnail READ hasThumbnail )
    Q_PROPERTY( QPixmap thumbnail READ thumbnail )

public:
    Task( WId win, TaskManager * parent, const char *name = 0 );
    virtual ~Task();

    TaskManager* taskManager() const { return (TaskManager*) parent(); }

    WId window() const { return _win; }
#if 0 // this would use (_NET_)WM_ICON_NAME, which is shorter, but can be different from window name
    QString visibleIconicName() const { return _info.visibleIconName(); }
    QString visibleIconicNameWithState() const { return _info.visibleIconNameWithState(); }
    QString iconicName() const { return _info.iconName(); }
#else
    QString visibleIconicName() const { return _info.visibleName(); }
    QString visibleIconicNameWithState() const { return _info.visibleNameWithState(); }
    QString iconicName() const { return _info.name(); }
#endif
    QString visibleName() const { return _info.visibleName(); }
    QString visibleNameWithState() const { return _info.visibleNameWithState(); }
    QString name() const { return _info.name(); }
    QString className();
    QString classClass();

    /**
     * A list of the window ids of all transient windows (dialogs) associated
     * with this task.
     */
    QValueList<WId> transients() const { return _transients; }

    /**
     * Returns a 16x16 (KIcon::Small) icon for the task. This method will
     * only fall back to a static icon if there is no icon of any size in
     * the WM hints.
     */
    QPixmap pixmap() const { return _pixmap; }

    /**
     * Returns the best icon for any of the KIcon::StdSizes. If there is no
     * icon of the specified size specified in the WM hints, it will try to
     * get one using KIconLoader.
     *
     * <pre>
     *   bool gotStaticIcon;
     *   QPixmap icon = myTask->icon( KIcon::SizeMedium, gotStaticIcon );
     * </pre>
     *
     * @param size Any of the constants in KIcon::StdSizes.
     * @param isStaticIcon Set to true if KIconLoader was used, false otherwise.
     * @see KIcon
     */
    QPixmap bestIcon( int size, bool &isStaticIcon );

    /**
     * Tries to find an icon for the task with the specified size. If there
     * is no icon that matches then it will either resize the closest available
     * icon or return a null pixmap depending on the value of allowResize.
     *
     * Note that the last icon is cached, so a sequence of calls with the same
     * parameters will only query the NET properties if the icon has changed or
     * none was found.
     */
    QPixmap icon( int width, int height, bool allowResize = false );

    /**
     * Returns true iff the windows with the specified ids should be grouped
     * together in the task list.
     */
    static bool idMatch(const QString &, const QString &);

    // state

    /**
     * Returns true if the task's window is maximized.
     */
    bool isMaximized() const;

    /**
     * Returns true if the task's window is minimized.
     */
    bool isMinimized() const;

    /**
     * @deprecated
     * Returns true if the task's window is minimized(iconified).
     */
    bool isIconified() const;

    /**
     * Returns true if the task's window is shaded.
     */
    bool isShaded() const;

    /**
     * Returns true if the task's window is the active window.
     */
    bool isActive() const;

    /**
     * Returns true if the task's window is the topmost non-iconified,
     * non-always-on-top window.
     */
    bool isOnTop() const;

    /**
     * Returns true if the task's window is on the current virtual desktop.
     */
    bool isOnCurrentDesktop() const;

    /**
     * Returns true if the task's window is on all virtual desktops.
     */
    bool isOnAllDesktops() const;

    /**
     * Returns true if the task's window will remain at the top of the
     * stacking order.
     */
    bool isAlwaysOnTop() const;

    /**
     * Returns true if the document the task is editing has been modified.
     * This is currently handled heuristically by looking for the string
     * '[i18n_modified]' in the window title where i18n_modified is the
     * word 'modified' in the current language.
     */
    bool isModified() const ;

    /**
     * Returns the desktop on which this task's window resides.
     */
    int desktop() const { return _info.desktop(); }
    
    /**
     * Returns true if the task is not active but demands user's attention.
     */
    bool demandsAttention() const;

    // internal

    //* @internal
    void refresh(bool icon = false);
    //* @internal
    void addTransient( WId w, const NETWinInfo& info );
    //* @internal
    void removeTransient( WId w );
    //* @internal
    bool hasTransient( WId w ) const { return _transients.contains( w ); }
    //* @internal
    void updateDemandsAttentionState( WId w );
    //* @internal
    void setActive(bool a);

    // For thumbnails

    /**
     * Returns the current thumbnail size.
     */
    double thumbnailSize() const { return _thumbSize; }

    /**
     * Sets the size for the window thumbnail. For example a size of
     * 0.2 indicates the thumbnail will be 20% of the original window
     * size.
     */
    void setThumbnailSize( double size ) { _thumbSize = size; }

    /**
     * Returns true if this task has a thumbnail. Note that this method
     * can only ever return true after a call to updateThumbnail().
     */
    bool hasThumbnail() const { return !_thumb.isNull(); }

    /**
     * Returns the thumbnail for this task (or a null image if there is
     * none).
     */
    const QPixmap &thumbnail() const { return _thumb; }

    /*!
        \fn Task::getGeometry()
     */
    QRect getGeometry()
    {
        /// @todo implement me
	return _info.geometry();
    }
    WId  getID();

public slots:
    // actions

    /**
     * Maximise the main window of this task.
     */
    void maximize();

    /**
     * Restore the main window of the task (if it was iconified).
     */
    void restore();

    /**
     * Iconify the task.
     */
    void iconify();

    /**
     * Close the task's window.
     */
    void close();

    /**
     * Raise the task's window.
     */
    void raise();

    /**
     * Lower the task's window.
     */
    void lower();

   /**
     * Activate the task's window.
     */
    void activate();

    /**
     * Perform the action that is most appropriate for this task. If it
     * is not active, activate it. Else if it is not the top window, raise
     * it. Otherwise, iconify it.
     */
    void activateRaiseOrIconify();

    /**
     * If true, the task's window will remain at the top of the stacking order.
     */
    void setAlwaysOnTop(bool);
    void toggleAlwaysOnTop();

    /**
     * If true then the task's window will be shaded. Most window managers
     * represent this state by displaying on the window's title bar.
     */
    void setShaded(bool);
    void toggleShaded();

    /**
     * Moves the task's window to the specified virtual desktop.
     */
    void toDesktop(int);

    /**
     * Moves the task's window to the current virtual desktop.
     */
    void toCurrentDesktop();

    /**
     * This method informs the window manager of the location at which this
     * task will be displayed when iconised. It is used, for example by the
     * KWin inconify animation.
     */
    void publishIconGeometry(QRect);

    /**
     * Tells the task to generate a new thumbnail. When the thumbnail is
     * ready the thumbnailChanged() signal will be emitted.
     */
    void updateThumbnail();
    void updateThumbnail(int);

signals:
    /**
     * Indicates that this task has changed in some way.
     */
    void changed();

    /**
     * Indicates that the icon for this task has changed.
     */
    void iconChanged();

    /**
     * Indicates that this task is now the active task.
     */
    void activated();

    /**
     * Indicates that this task is no longer the active task.
     */
    void deactivated();

    /**
     * Indicates that the thumbnail for this task has changed.
     */
    void thumbnailChanged(Task *);

protected slots:
    //* @internal
    void generateThumbnail();

private:
    bool                _active;
    WId                 _win;
    QPixmap             _pixmap;
    KWin::WindowInfo    _info;
    QValueList<WId>     _transients;
    QValueList<WId>     _transients_demanding_attention;

    int                 _lastWidth;
    int                 _lastHeight;
    bool                _lastResize;
    QPixmap             _lastIcon;

    double _thumbSize;
    QPixmap _thumb;
    QPixmap _grab;

    class TaskPrivate *d;
};

/**
 * Represents a task which is in the process of starting.
 *
 * @see TaskManager
 */
class Startup: public QObject
{
    Q_OBJECT
    Q_PROPERTY( QString text READ text )
    Q_PROPERTY( QString bin READ bin )
    Q_PROPERTY( QString icon READ icon )

public:
    Startup( const KStartupInfoId& id, const KStartupInfoData& data, QObject * parent,
        const char *name = 0);
    virtual ~Startup();

    /**
     * The name of the starting task (if known).
     */
    QString text() const { return _data.findName(); }

    /**
     * The name of the executable of the starting task.
     */
    QString bin() const { return _data.bin(); }

    /**
     * The name of the icon to be used for the starting task.
     */
    QString icon() const { return _data.findIcon(); }
    void update( const KStartupInfoData& data );
    const KStartupInfoId& id() const { return _id; }

signals:
    /**
     * Indicates that this startup has changed in some way.
     */
    void changed();

private:
    KStartupInfoId _id;
    KStartupInfoData _data;
    class StartupPrivate *d;
};

typedef QPtrList<Task> TaskList;
typedef QPtrList<Startup> StartupList;


/**
 * A generic API for task managers. This class provides an easy way to
 * build NET compliant task managers. It provides support for startup
 * notification, virtual desktops and the full range of WM properties.
 *
 * @see Task
 * @see Startup
 * @see KWinModule
 * @version $Id: taskmanager.h,v 1.47 2003/12/11 13:25:31 lunakl Exp $
 */
class TaskManager : public QObject
{
    Q_OBJECT
    Q_PROPERTY( int currentDesktop READ currentDesktop )
    Q_PROPERTY( int numberOfDesktops READ numberOfDesktops )

public:
    TaskManager( QObject *parent = 0, const char *name = 0 );
    virtual ~TaskManager();

    /**
     * Returns a list of all current tasks. Return type changed to
     * QPtrList in KDE 3.
     */
    TaskList tasks() const { return _tasks; }

    /**
     * Returns a list of all current startups. Return type changed to
     * QPtrList in KDE 3.
     */
    StartupList startups() const { return _startups; }

    /**
     * Returns the name of the nth desktop.
     */
    QString desktopName(int n) const;

    /**
     * Returns the number of virtual desktops.
     */
    int numberOfDesktops() const;

    /**
     * Returns the number of the current desktop.
     */
    int currentDesktop() const;

    /**
     * Returns true if the specified task is on top.
     */
    bool isOnTop( const Task*);
signals:
    /**
     * Emitted when a new task has started.
     */
    void taskAdded(Task*);

    /**
     * Emitted when a task has terminated.
     */
    void taskRemoved(Task*);

    /**
     * Emitted when a new task is expected.
     */
    void startupAdded(Startup*);

    /**
     * Emitted when a startup item should be removed. This could be because
     * the task has started, because it is known to have died, or simply
     * as a result of a timeout.
     */
    void startupRemoved(Startup*);

    /**
     * Emitted when the current desktop changes.
     */
    void desktopChanged(int desktop);

    /**
     * Emitted when a window changes desktop.
     */
    void windowChanged(WId);
    void taskActivated(Task*);

protected slots:
    //* @internal
    void windowAdded(WId);
    //* @internal
    void windowRemoved(WId);
    //* @internal
    void windowChanged(WId, unsigned int);

    //* @internal
    void activeWindowChanged(WId);
    //* @internal
    void currentDesktopChanged(int);
    //* @internal
    void killStartup( const KStartupInfoId& );
    //* @internal
    void killStartup(Startup*);

    //* @internal
    void gotNewStartup( const KStartupInfoId&, const KStartupInfoData& );
    //* @internal
    void gotStartupChange( const KStartupInfoId&, const KStartupInfoData& );
    //* @internal
    void gotRemoveStartup( const KStartupInfoId& );

protected:
    /**
     * Returns the task for a given WId, or 0 if there is no such task.
     */
    Task* findTask(WId w);
    void configure_startup();

private:
    Task*               _active;
    TaskList           _tasks;
    QValueList< WId >   _skiptaskbar_windows;
    StartupList         _startups;
    KStartupInfo*       _startup_info;

    class TaskManagerPrivate *d;
};



/*--HEADERSTOP--*/
/*--HEADERSTART--*/


#include <qobject.h>
#include <qstring.h>
#include <qstringlist.h>
#include <qimage.h>
#include <qxml.h>
#include <qdom.h>





const uint MAX_STRING_NAME 	= 50;
//const int MAX_FILE_LENGTH 	= 1024;
const uint MAX_ICONS		= 50;


struct XSGObject
{
	QString className;
	QString fileName;
	QString Name;
	QString Group;
};
struct XSGObjectIconImages
{
	QString imgFileName;
	QString imgFileArrow;
	QString imgFileDrop;
	QString imgFileOverlay;
	QString imgFileOverlaySpinner;
	
};

#ifdef ENABLE_STATS
struct XSGObjectIconStatistics
{
	int onClickExec;
	int onDropExec;
	int onBounce;
	int dockerIndexSum;
};
struct XSCfgStatistics
{
	int dockerStarts;
	int dockerDaysRunning;
	int dockerHoursRunning;
	int dockerMinutesRunning;
	int dockerSecondsRunning;
	int dockerFirstStart;
	int maxIconsDisplayed;
	int avgIconsDisplayed;
	int avgCounter;
	int changedBackgroundTheme;
	int startedConfigurator;
	uint lastStart;

};
#endif

struct XSGObjectIconActions
{
	QString onClickExec;
	QString onDropExec;
	QDomNodeList		ActionList;
	int	iAnimationMask;
};
struct XSCfgTextFont
{
	int FontRed;
	int FontGreen;
	int FontBlue;
	QString FontFamily;
	int	FontSize;
	QString BackgroundPath;
	int	Bold;
	int	Italic;
	int	OtherBinaryValue;
	int	Weight;
	int	Other;
	QString	Alias;
	int	XPercentageDisplacement;
	int	YPercentageDisplacement;

};

struct XSCfgTasks
{
	void 		*TaskInfo;
	int		ShowThumbnail;
	QImage		Thumbnail;
	QStringList	WindowTitle;
	QStringList	TaskName;
	QStringList	ClassName;
	QPtrList<QObject> Proces;
	class KPopupMenu	*PopupMenu;
	QStringList	dcopName;
	QString		dcopRestore;
	QString		dcopClose;
	QString		dcopNewWindow;
	int		dcopReady;
	int		forceRunning;
	//int		forceNumber;
	//int		forceString;
	//int		Number;
	QString		MiniText;
	int		MiniTextShow;
	XSCfgTextFont	MiniTextProperty;
};

struct XSGObjectIcon
{
	XSGObject		Info;
	XSGObjectIconImages	Images;
	XSGObjectIconActions	Actions;
	XSCfgTasks		Tasks;
	QString			OverText;
	QDomNodeList		PluginConfiguration;
	//QImage			Poof;
	QString			PoofName;
	class KPopupMenu	*PluginPopupMenu;
	int			TimeToLive;
#ifdef ENABLE_STATS
	XSGObjectIconStatistics	Statistics;
#endif
};
struct XSCfgMatchIcons
{
	QString				SystemName;
	XSGObjectIcon			*Icon;
};
struct XSGObjectPlugin
{
	XSGObject			Info;
	QDomNodeList			xmlConfiguration;
};
struct XSCfgPlugins
{
	QPtrList<XSCfgMatchIcons> 	Matches;
	QStringList			PluginsPaths;
	QPtrList<XSGObjectPlugin>	Plugin;
};
struct XSCfgIcons
{
	int Size;
	int SizePrefer;
	int SizeBig;
	int Raise;
	int Separation;
	int Horiz;
	int EnableThumbnail;
	XSCfgTextFont	OverTextFont;
	XSCfgTextFont	MiniTextFont;
	
};

struct XSGCfgBackground
{
	QString			imgBackgroundCenter;
	QString			imgBackgroundLeft;
	QString			imgBackgroundRight;
	QString			imgBackgroundOver;
	int			Tiled;
	QString			imgBackgroundSeparator;
	int			Desaturate;
};
struct XSCfgTheme
{
	XSGObject		Info;
	QString			BackgroundPath;
	XSGCfgBackground	Background;
	QString			ArrowsPath;
//	QString			PillowPath;
//	QString			MiniPillowPath;
	QString			PoofPath;
	QImage			Poof;
	QStringList		IconsPaths;
	QPixmap			DefaultIcon;
};

struct XSCfgWindow
{
	int borderLeft;
	int borderTop;
	int Width;
	int Height;
	int Top;
	int Left;
	//char Align[MAX_STRING_NAME];
	QString Align;
	int HeightDesktop;
	int LeftForce;
	int TopForce;
	
	int HideTimeout;
	int FastHide;
	int HideMouseEdge;
	
	int SendToForgroundTimeout;
	int RaiseOnEvents;
	
	int SendToBackground;
	
	int HideMouseCornerLeft;
	int HideMouseCornerRight;
};

struct XSDesignMatrix
{
	// number of elements
	int sizeMatrix;
	// 2d X Axis displace on mouse over
	int *XMatrix;
	// 2d Y Axis displace on mouse over
	int *YMatrix;
	// 2d Zoom on mouse over
	int *ZMatrix;
	// 3d Dinamic Axis displace on mouse over
	int **DMatrix;
	// 2d X+ Axis displace on mouse over
	int *KMatrix;

	int DesignDMoltiplier;
	int DesignYMoltiplier;
	int DesignXMoltiplier;
	
	QString Design;
};

struct XSEngine
{
	int SmoothTimeout;
	//char XMLConf[512];
	QString XMLConf;
	int SleepFPS;
	//int IconsShowed;
	int SleepThreads;
	int SleepAnimations;
	int MaxIconsShowed;
//	int StaticIconsShowed;
	int AndZoomCache;
#ifdef ENABLE_SPECIALENGINE2
	int InterpolationValue;
#endif
};

struct XSConfigurations
{
	QString		Version;
	int		AutoSave;
	int		AutoResize;
	XSCfgIcons	Icons;
	XSCfgWindow	Window;
	XSDesignMatrix	Matrix;
	XSEngine	Engine;
	//XSGObjectIcon	ObjectsIcon[MAX_ICONS];
	QPtrList<XSGObjectIcon> ObjectsIcons;
	QPtrList<XSGObjectIcon> RollingIcons;
	XSCfgTheme	Theme;
	XSCfgPlugins	Plugins;
#ifdef ENABLE_STATS
	XSCfgStatistics	Statistics;
#endif	
	QStringList	ConfigurationsPaths;
};


/**
@author Stefano
*/
class XEConfiguration : public QObject
{
Q_OBJECT
public:
    XEConfiguration(QObject *parent = 0, const char *name = 0);

    ~XEConfiguration();
    XSConfigurations * xGetConfiguration();
    XSGObjectIcon * iconAddSeparator();
    XSGObjectIcon * iconAdd();
public slots:
    void xReset();
    void xCfgDefault();
    void xSetup();
    void xEventInRemovingIcon(int,int);
    void xLoadModules();
    void xLoadModule(const QString moduleName);
    void pluginRemove(const QString);
    void pluginAdd(const QString);
    void xGetConfiguration(void *&,const QString, int);
    void xGetConfigurationVersion(int &, QString &);
    void xGetConfigurationValue(const QString, QStringList &);
    void xGetConfigurationValue(const QString, int &);
    void xGetConfigurationValue(const QString, QString &);
    void xSetConfigurationValue(const QString, QString &);
    void xEventConfigurationUpdated(const QString);
    void xSetConfigurationValue(const QString, int &);
    void xEventInReloadIcon(int);
    void xFindResource(const QString &, QString &);
    void xParse(const QString &, int, void *);
    void xSwapIcons(int,int);
protected:
    XSConfigurations ActiveConfiguration;
    QStringList _ValuesList;

signals:
    void xCfgChanged(QObject *);
    void xEventReloadIcon(int);
    void xEventRemovingIcon(int,int);
    void xEventRemovedIcon(int);
protected:
    void * xGetConfigurationPointer(const QString);
    void * getConfigurationPointerObject(const QStringList,int,XSGObjectIcon *);
private:
    QString xFindIconFile(const QString &);
    inline int xLoadModuleTest(const QString &);
};


/*--HEADERSTOP--*/
/*--HEADERSTART--*/


#include <qptrlist.h> 
#include <qstringlist.h>
/*
#include <time.h>

extern timespec microSeconds;
//void minisleep(unsigned long);


static void minisleep(unsigned long uSeconds)
{
	static timespec rem;
	microSeconds.tv_nsec=1000*uSeconds;
	microSeconds.tv_sec=0;
	nanosleep(&microSeconds,&rem);
}
*/




/**
@author Stefano
*/
class XEObject : public QObject
{
Q_OBJECT
public:
    XEObject(QObject *parent = 0, const char *name = 0);

    ~XEObject();
    static QObject * xGetRoot();
    static QObject * xGetConfiguration();
    static QObject * xGetMatrix();
    static QObject * xGetDocker();
    static QObject * xGetXMLParser();
    static QObject * xFindObject(const QString &hisName);
    
    static void xSetEngineDocker(QObject *);
    static void xSetXMLParser(QObject *);
    static void xSetEngineEvents(QObject *);
    static void xSetEngineConfiguration(QObject *);
    static void xSetEngineMatrix(QObject *);
    void xWarningMsg(const QObject *, const QString &);
    static const QStringList xGetPluginListNames();
    static int xGetPluginIndex(QObject *);
protected:
    static QObject * xEngineRoot;
    static QObject * xEngineMatrix;
    static QObject * xXMLParser;
    static QObject * xEngineDocker;
    static QObject * xEngineConfiguration;
    static QObject * xEngineEvents;
    static QPtrList<QObject> xPlugins; 
    static QStringList	xPluginList;
public slots:
    
    static void xPluginAdd(QObject *);
    static void xPluginDel(QObject *);
    void xGetDocker(QObject *&);
    void xGetConfiguration(QObject  *&);
    void xParse(const QString &, int, void *);
};

/*--HEADERSTOP--*/
/*--HEADERSTART--*/

#include <qobject.h>

/**
	@author Stefano Zingarini <stefano@xiaprojects.com>
*/
class XEPlugin_GUILogger : public QObject
{
Q_OBJECT
public:
    XEPlugin_GUILogger(QObject *parent = 0, const char *name = 0);

    ~XEPlugin_GUILogger();

public slots:
    void xParse(const QString &, int, void *);
    void xLog(int,int,const QString &);
    void xSetup();
    void xStart();
    void xStop();
    void xLog(int,const QString &,const QString &);
};

/*--HEADERSTOP--*/
/*--HEADERSTART--*/


#include <qobject.h>
#include <qxml.h>
#include <qfile.h>
#include <qxml.h>
#include <qdom.h>

/**
@author Stefano
*/
class XEPlugin_XMLConf : public QObject, public QXmlDefaultHandler
{
Q_OBJECT

public:
    XEPlugin_XMLConf(QObject *parent = 0, const char *name = 0);

    ~XEPlugin_XMLConf();
    bool startDocument();
    bool startElement( const QString&, const QString&, const QString& ,const QXmlAttributes& );
    bool endElement( const QString&, const QString&, const QString& );
    void xmlFetchPlugins(QDomNodeList &xmlIcons);
    static void xmlFetch(const QString &tagName,int &retValue,QDomNodeList &xmlEngine);
    void xXMLExplode();
    void xImportXMLs();
protected:
    QFile 	xmlFile;
    int		xmlLevel;
    class XSConfigurations *ActiveConfiguration;


public slots:
    void xStart();
    void xStop();
    void xSetup();
    void xXMLStore(const QString &);
    void xXMLStore();
    void xLoadXML(const QString);
    void xSave();
protected:
    void xmlFetchObjectsIcons(QDomNodeList &xmlIcons,class XSGObjectIcon *storageIcon=NULL);
    void xmlFetchObjectsPlugins(QDomNodeList &xmlIcons);
protected:
    void xmlFetchPathsIcons(QDomNodeList &xmlIcons);
    void xmlFetchPathsPlugins(QDomNodeList &xmlIcons);
    void xmlStoreObjectsIcons(QDomDocument &doc, QDomElement &root, class XSGObjectIcon *icon);
    void xCfgStore(QDomDocument &doc, QDomElement &root);
    QDomNodeList makeNodeList(QObject *);
signals:
    void clientGetParameterList(QStringList *);
    void clientGetParameter(const QString,QString&);
};


/*--HEADERSTOP--*/
/*--HEADERSTART--*/

#include <qobject.h>

/**
@author Stefano
*/
class XERoot : public XEObject
{
Q_OBJECT
public:
    XERoot(QObject *parent = 0, const char *name = 0);

    ~XERoot();

public slots:
    void xSetup();
    void xStart();
    void xStop();
    void xStartThis(const QString&);
    void xSetupThis(const QString &);
    void xStopThis(const QString &);
    void xParseTo(const QString &, const QString &, int, void *);
    void xParse(const QString &, int, void *);
signals:
    void xPluginSetup();
    void xPluginStart();
    void xPluginStop();
    void xThisPluginSetup();
    void xThisPluginStart();
    void xThisPluginStop();
    void xParseForeign(const QString &, int, void *);
};

/*--HEADERSTOP--*/
/*--HEADERSTART--*/

#include <qobject.h>

/**
@author Stefano Zingarini
*/
class XEWorld : public QObject
{
Q_OBJECT
public:
    XEWorld(QObject *parent = 0, const char *name = 0);

    ~XEWorld();

};
/*--HEADERSTOP--*/
/*--HEADERSTART--*/
#include <qwidget.h>

class XGIcon;
class QTimer;
class XSConfigurations;


/**
	@author Stefano Zingarini <stefano@xiaprojects.com>
*/
class XGDocker : public QWidget
{
Q_OBJECT
public:
    XGDocker(QWidget *parent = 0, const char *name = 0,int i=0);

    ~XGDocker();
    virtual void xDockerRedraw(QObject *);
    virtual XGIcon * xGetPointerObjectIcon(int);
    virtual int getRaised();
    virtual void xUpdate(int t=0,int p=0);
    virtual QImage * xGetBackground();
    virtual void xCheckBackgroundSeparators();
    virtual int xGetIconIndex(const QObject*);
    virtual void mouseMoveEventSW(int,int,int force=0,Qt::ButtonState button=Qt::NoButton);
    virtual void paintIn(QImage &,int);
    QTimer * polling;
	int isAnimating;
	int xLastX,xLastY;

public slots:
    virtual void xChangeBackground(const QString &);
    virtual void xGetObjectIcon(int,XGIcon *&);
//    virtual void xReloadIcon(int);
    virtual void xEventTaskAppend(int);
    virtual void xGetInfo(QStringList &);
    virtual void xStart();
    virtual void xStep();
    virtual void xStop();
    virtual void xEventReloadIcon(int);
    virtual void wheelEvent(QWheelEvent *);
    virtual void xParse(const QString &, int, void *);
    virtual void xUpdateRepaint(int);
    virtual void xSetup();
    virtual void xEventShowRaised();
    virtual void xMouseMoveSoftware(int,int);
    virtual void paint(QImage &);
    virtual void xDockerRedraw();
    virtual void xSwapIcons(int,int);
    virtual void xUpdateSense();
protected:
    class XSConfigurations *ActiveConfiguration;
};

/*--HEADERSTOP--*/
/*--HEADERSTART--*/


#include <qwidget.h>
#include <qimage.h>
#include <qbitmap.h>
#include <qwmatrix.h>
#include <qpoint.h>
#include <qpixmap.h>

//class XEPlugin_GEPillow;

// 0.32
//const int MAX_CACHE_ICONS=129;
// 256 + 1 + 16 273
#ifndef DISABLE_HUGE_CACHE
	const int MAX_CACHE_ICONS=257+16;
#endif
QImage *setIntensity(QImage &,double);

class XGIconTextMaker
{
public:
	XGIconTextMaker();
	virtual ~XGIconTextMaker();
	virtual void xSetFontStyle(const XSCfgTextFont *);
	virtual void xSetText(const QString &);
	virtual void xDrawText();
	virtual QPixmap *xGetPixmapText();
	int isPixmapTextDrawed;
	int xTextDecentre;
	int isTextDrawed;
	int PillowIsLoaded;
	QString	pillowText;
	QImage PPillow_Center;
	QImage PPillow_Left;
	QImage PPillow_Right;
	QImage TMiniBuffer;
	QImage TBuffer;
	QPixmap xImgText;
	QImage xImageText;
	QPixmap	overTextBuffer;
	QBitmap	overTextMask;
	static XSConfigurations * ActiveConfiguration;
	const XSCfgTextFont *FontStyle;
	QString BackgroundPath;
	void xSetBackgroundPath(const QString &);
protected:
	virtual void xPreparePillow(QRect &);
};
/**
@author Stefano
*/
class XGIcon : public QWidget
{
Q_OBJECT
public:
	XGIcon(QWidget *parent = 0, const char *name = 0);
	~XGIcon();
public slots:
	void xColorize(int,int,int);
	void xColorize(int,int,int,int);
	void xRedraw();
	void cachePurge();
	void xSetImage(const QString &);
	void xLoadIcon(const QString &);
	void xReset();
	void xSetImage(const QPixmap &);
	void xSetClass(QObject *);
	void xSetText(const QString &);
	void xGetImage(QImage *&);
	void xSetSmoothZoom();
	void xGetConfiguration(const XSGObjectIcon *&);
	void xGetPluginConfiguration(const QDomNodeList *&);
	void xSetZoom();
	void createPopup();
	void getPopupMenu(KPopupMenu *&);
	void xStartClass();
	void xSetupClass();
	void xGetPluginPopupMenu(KPopupMenu *&);
	void xStopClass();
	void xRunConfiguratorClass();
	void xSetIconEXE(const QString &);
	void xGetIconEXE(QString &);
	void xGetIconImgFile(QString &);
	void xGetIconName(QString &);
	void xSetIconImgFile(const QString &);
	void xSetIconName(const QString &);
	void xSetOverText(const QString &);
	void xDesaturate(float);
	void xFade(int);
	void xSetText(const QString &,int);
	void xSetMiniText(const QString &);
	void xSetTextManagedBy(int,int);
	void xMouseMoved(int,int,int,int,int,int);
	void xSetOverlayImage(int,int,const QPixmap &);
	void xSetOverlayImage(int,int,const QImage &);
	void xSetOverlayImage(int,int,const QString &);
	int xGetHidden();
	void xSetHidden();
	void xSetHidden(int);
	void xStep();
	void xFade(double);
	void xFadeTo(double);
	void xReSetClass(QObject *);
	void xFreeClass();
protected:
#ifndef DISABLE_HUGE_CACHE
    int		xImgCachedZoom[MAX_CACHE_ICONS];
    QImage	xImgCached[MAX_CACHE_ICONS];
#else
    int		xImgCachedZoomSingle;
    QImage	xImgCachedSingle;
#endif
	QObject	*xClassManager;
public:
	void xSetHotspot(const QPoint &);
	void xRepeat(int rWidth,int rHeight);
	void xSetIntensity(float);
	void xResetIntensity();
	static int xGetFontHeight();
	void xSetSmoothZoom(int);
	void xStartAnimating();
	void xStopAnimating();
	int xEnabledClickClass();
	void xEventClickClass(int,int,int);
	void xEventPostSetIconPos(int,int,int,int);
	XGIconTextMaker xIconTextPillow;
	XGIconTextMaker xIconTextMini;
	void xSetZoom(int,int);
	void xSetZoom(int);
	QWidget *wExternal;
	unsigned long iExternal;
	void xColorize(double,double,double,double);
    QObject * xGetClass();
	int hidden;
	QPoint 	xHotspot;
	const XSGObjectIcon *iconConfiguration;
	short int	xExclude;
	int	xAndZoomCache;
	static XSConfigurations * ActiveConfiguration;
	int 	xZoom;
	int 	xZoomX;
	int 	xZoomY;
	int		xSetUpdate;
	QImage 	xImgShowed;
	QImage 	xImgArrow;
	QImage 	xImgDrop;
	QImage 	xImgOverlay;
	QImage 	xImgArrowSource;
	QPoint 	xPosition;
	QImage	Poof;
	QPoint 	xPosDefault;
	QPoint 	xPosFixed;
	QBitmap 	xTransparency;
	QImage 	xImgSource;
	QImage 	xImgOriginal;
	//XEPlugin_GEPillow *xPillow;
	double dAnimateNowFade;
	double dAnimateToFade;
	int	dAnimateStatus;
	int	dAnimateStep;
signals:
	void xAttach(QObject *);
	void xRefresh(QObject *);
	void xEventStartAnimating();
	void xEventStopAnimating();
	void xStart();
	void xSetup();
	void xEventClick(void *,int,int,int,int);
	void xEnabledClick(int &);
	void xStop();
	void xRunConfigurator();
	void xEventSetIconPos(int,int,int,int);
	void xEventMouseMoved(int,int,int,int,int,int);
protected:
	void setOverlay(int,int,const QImage &);
	void fFade(double);
	void fSpin();
};

/*--HEADERSTOP--*/
#endif
